
/******************************************************************************
 *  problem1.c : a sample realtime app
 ******************************************************************************/
#ifdef __USAGE
%C [ -p priority ]

priority   = priority to run at (0 to 29) Default=10
e.g. 
%C -p 29
#endif
 
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/kernel.h>
#include <sys/vc.h>
#include <sys/seginfo.h>
#include <sys/osinfo.h>
#include <sys/name.h>
#include <i86.h>
#include <conio.h>
#include <sys/irqinfo.h>
#include <sys/proxy.h>
#include <sys/sched.h>
#include <sys/timers.h>
#include <sys/name.h>
#include <fcntl.h>
#include <errno.h>
#include <string.h>
#include <sys/trace.h>
#include <sys/tracecod.h>
#include <math.h>
#include <time.h>
#include <signal.h>

/* globals */
int                 priority = 10;
pid_t				t_proxy;
struct itimerspec	timer;
struct sigevent		t_event;

#define POLL_RATE_IN_NSEC 1000000000  // 1 millisecond = 1000000000 nanoseconds

main(int argc, char **argv) {
    int     c;

    while ( ( c = getopt( argc, argv, "p:" ) ) != -1 ) {
         switch(c) {
            case 'p' : priority = atoi(optarg);
                       if ( priority < 0 || priority > 29 ) {
                          fprintf(stderr,"Invalid priority. Defaulting to 10.\n");
                          priority = 10;
                          }
                       break;
            }
         }

    if ( setprio( getpid(), priority ) == -1 ) {
       fprintf(stderr,"Error setting priority. (%s)\n",strerror(errno));
       exit(-1);
       }

    prepare_to_go();

    go();

	}

prepare_to_go() {
	int id;

	t_proxy = qnx_proxy_attach( 0, 0, 0, -1 );
	if ( t_proxy == -1 )
	{
		perror( "qnx_proxy_attach:" );
		exit( -1 );
	}

	t_event.sigev_signo = -t_proxy;
	id = timer_create( CLOCK_REALTIME, &t_event );
	if ( id == -1 )
	{
		perror( "timer_create:" );
		exit( -1 );
	}
	timer.it_value.tv_sec     = 0L;
	timer.it_value.tv_nsec    = POLL_RATE_IN_NSEC;
	timer.it_interval.tv_sec  = 0L;
	timer.it_interval.tv_nsec = POLL_RATE_IN_NSEC;
	timer_settime(id, 0, &timer, NULL);
	}

go() {
	pid_t pid;
	char msg;
    int i;
    unsigned short c[5];
    double tmp;

    while (1) {              
        pid = Receive( 0, &msg, sizeof(msg) );

        // read 5 port values
        for ( i=0; i < 5; i++ )
            c[i] = inp(0x42);

        // do some math on them
        tmp = c[0] * c[1] * sin(c[2]+c[3]) + c[4];  
        }
	}

